#ifndef _FOR_H
#define _FOR_H

#include "IF.h"

/* This template repeats a code by the select number of times without overhead.


Template parameters
- int n: number of times to repeat the code
- class Statement: code to repeat. The code must be specified in the following concept:
     class MyClassName
     {
          static void execute() { // code to execute here }
     }

*/


template <int n, class Statement>
struct FOR
{
    inline static void execute()
    {
        Statement();
        FOR <n - 1, Statement >::execute();
    }
};

template <class Statement>
struct FOR <0, Statement>
{
    inline static void execute() { }
};


#endif // _FOR_H
