
#include "lista.h"
#include "IF.h"
#include "FOR.h"
#include "WHILE.h"
#include <iostream>
#include "smp_inherit.h"

using namespace std;

typedef GenerateSubClass<int, 
                         LinkedNode, 
                         SubTypeList<DoublyLinkedNode,
                           SubTypeList<LengthNode > > 
                        >::ResultType NodeType;


typedef GenerateSubClass<NodeType, ForwardIterator, SubTypeList<BidirectionalIterator> >::ResultType IteratorType;

typedef GenerateSubClass<NodeType, ForwardIterator, SubTypeList<RevIterator, SubTypeList<BidirectionalIterator> > >::ResultType RevIteratorType;

int main()
{
    NodeType x(10);

    x.addAfter(20);
    x.addAfter(30);
    x.addAfter(40);
    x.addAfter(50);

    x.addBefore(10000);
    x.addBefore(20000);

    IteratorType it(&x);

    while (it.isValid())
    {
        cout << *it << endl;
       
        it++;
    }

    NodeType *last = (x.next)->next->next;

    IteratorType it2(last);

    cout << endl;

    while (it2.isValid())
    {
        cout << *it2 << endl;
       
        it2--;
    }

    cout << "rev iterator" << endl;

    RevIterator<IteratorType> it3(&x);

    while (it3.isValid())
    {
        cout << *it3 << endl;
       
        it3--;
    }

    last = (x.next)->next->next;

    RevIteratorType it4(last);

    cout << endl;

    while (it4.isValid())
    {
        cout << *it4 << endl;
       
        it4++;
    }



    int tamanho = x.getNumberOfFollowers();

    cout << "Static List size is: " << tamanho + 1 << endl;

    //typedef BaseList<int, ListConfig<NodeType, IteratorType> > ListType;

    //ListType list(&x);

    LinkedList<int> list;

    list.addFirst(10);
    list.addLast(20);
    list.addFirst(5);

    LinkedList<int>::IteratorType ite = list.getFirst();

    cout << "Now using LinkedList!"<< endl;

    while (ite.isValid())
    {
        cout << *ite <<endl;

        ite++;
    }

    Stack<int, true> stack;

    stack.push(10);
    stack.push(20);
    stack.push(5);

    cout << "Now using Stack!" << endl;

    while (!stack.isEmpty())
    {
        cout << stack.peek() <<endl;

        stack.pop();
    }

    Queue<int> queue;

    queue.push(10);
    queue.push(20);
    queue.push(5);

    cout << "Now using queue!" << endl;

    while (!queue.isEmpty())
    {
        cout << queue.peek() <<endl;

        queue.pop();
    }

    Deque<int> deque;

    deque.pushFront(10);
    deque.pushFront(20);
    deque.pushFront(5);

    cout << "Now using Deque!" << endl;

    while (!deque.isEmpty())
    {
        cout << deque.peekFront() <<endl;

        deque.popFront();
    }

    cout << "  - Back!" << endl;

    deque.pushBack(10);
    deque.pushBack(20);
    deque.pushBack(5);

    cout << "Now using Deque!" << endl;

    while (!deque.isEmpty())
    {
        cout << deque.peekBack() <<endl;

        deque.popBack();
    }

    return 0;
}

